#include <cv.h>					// includes OpenCV definitions
#include <highgui.h>				// includes highGUI definitions
#include <cstdio>					// perror, printf, sprintf

int main()
{
	cv::Mat imagenCamara;					/** Imagen capturada de la camara */
	cv::VideoCapture streamCapture(0);	/** flujo de captura de la camara */
	streamCapture >> imagenCamara;	/** Se realiza una primera captura de la webcam y se inicializa imagenCamara */
		
	if ( !streamCapture.isOpened() || imagenCamara.empty())
		printf("Error abriendo cámara\n");
	else
	{
		printf("Pulsa escape para finalizar el programa.\n");
		cv::namedWindow("Camara", CV_WINDOW_AUTOSIZE);
		cv::VideoWriter streamWriter("videoSalida.avi", CV_FOURCC('I','4','2','0'), 25, imagenCamara.size() ,1);	/** flujo de salida de vídeo */
		char userKey = 0;		/** tecla pulsada por el usuario */
		while (userKey != 27)
		{
			streamCapture >> imagenCamara;
			if ( imagenCamara.empty() )
			{
				printf("Error leyendo imagen de la cámara");
				exit(0);
			}
			else
			{
				cv::imshow("Camara", imagenCamara);
				streamWriter << imagenCamara;
				userKey = cv::waitKey(40);
			}
		}
	}
	return(0);
}
